/*
 * =====================================================================================
 *
 *       Filename:  =linklist_main.cpp
 *
 *    Description:  Test Program for Link List with MYSQL
 *
 *        Version:  1.0
 *        Created:  03/29/2011 03:32:04 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ruben Safir, 
 *        Company:  NYLXS
 *
 * =====================================================================================
 */

#ifndef  LINKLIST
#define LINKLIST
#include	"linklist.h"
#include	"message.h"
#endif     /* -----  not LINKLIST  ----- */

#include	<iostream>
#include	<fstream>
#include 	<climits>
#include 	<cstdlib>
#include 	<cstdio>
#include	<string>
#include 	<iomanip>
#include 	<mysql++.h>

template<typename T>
void start_list_with_five_things(T,T,T,T,T);

template<typename T>
void add_to_list_with_five_things(T,T,T,T,T);


template<typename T>
void add_to_list_with_five_things_then_find(T,T,T,T,T);


	template <class T>
void find_all_examples (chainlist::List<T>&, T const &  );

chainlist::List<mess::MESSAGE> get_messages();
chainlist::Node<std::string> * findtest(std::string);
chainlist::List<int>& creating_int_list();

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  main
 *  Description:  
 * =====================================================================================
 */
int main ( int argc, char *argv[] )
{ 
	
	chainlist::Node<std::string> * string_node;
	chainlist::List<int> myintlist;


	std::string search_string = "His reputation for a ready-moneyed man, who would lend money out for a";
	string_node = findtest(search_string);
	if(string_node){
		std::cout << "************************************************************FOND NODE***********" << std::endl;
		std::cout	<< "With Value ==> '" << search_string << "'" << std::endl;
		
		std::cout	<< "Node is ==> '"<< string_node << "' Value is ==> '" << *(string_node->value()) << "'" << std::endl;
	}else{
		std::cout << "***********************************Not Found************************************" << std::endl;
		std::cout << search_string << std::endl;
	}

	
	search_string = "throughout New England, of \"The devil and Tom Walker.\"";

	string_node = findtest(search_string);
	if(string_node){
		std::cout << "************************************************************FOND NODE***********" << std::endl;
		std::cout	<< "With Value ==> '" << search_string << "'" << std::endl;
		
		std::cout	<< "Node is ==> '"<< string_node << "' Value is ==> '" << *(string_node->value()) << "'" << std::endl;
	}else{
		std::cout << "***********************************Not Found************************************" << std::endl;
		std::cout << search_string << std::endl;
	}

	search_string = "This is never going to be found";
	string_node = findtest(search_string);
	if(string_node){
		std::cout << "************************************************************FOND NODE***********" << std::endl;
		
		std::cout	<< "With Value ==> '"<<  search_string << "'" << std::endl;
		std::cout	<< "Node is ==> '"<< string_node << "' Value is ==> '" << *(string_node->value()) << "'" << std::endl;
	}else{
		std::cout << "***********************************Not Found************************************" << std::endl;
		std::cout << search_string << std::endl;
	}

	
	
	start_list_with_five_things<std::string>("See", "Spot", "Run", "Run", "Fast!!");
	start_list_with_five_things("See", "Spot", "Run", "Run", "Fast!!");
	start_list_with_five_things(5,7,0,6,9);
	start_list_with_five_things('a','f','g','s','l');
	start_list_with_five_things(2.4, 4.3445, 3.566, 7.33234, 3.14545654645646466 );
	myintlist = creating_int_list();
	find_all_examples(myintlist, 4);


	chainlist::List<mess::MESSAGE> email = get_messages();
	email.cursor() = email.front();
	while(email.cursor() != email.endd()){
		std::cout << "Messages Outside of func:\n" << *(email.cursor()->value()) << std::endl;
		email.cursor() = email.cursor()->next();
	}
	add_to_list_with_five_things<std::string>("See", "Spot", "Run", "Run", "Fast!!");
	add_to_list_with_five_things("See", "Spot", "Run", "Run", "Fast!!");
	add_to_list_with_five_things(5,7,0,6,9);
	add_to_list_with_five_things('a','f','g','s','l');
	add_to_list_with_five_things(2.4, 4.3445, 3.566, 7.33234, 3.14545654645646466 );
	
	add_to_list_with_five_things_then_find<std::string>("See", "Spot", "Run", "Run", "Fast!!");
	add_to_list_with_five_things_then_find("See", "Spot", "Run", "Run", "Fast!!");
	add_to_list_with_five_things_then_find(5,7,0,6,9);
	add_to_list_with_five_things_then_find('a','f','g','s','l');
	add_to_list_with_five_things_then_find(2.4, 4.3445, 3.566, 7.33234, 3.14545654645646466 );
	return EXIT_SUCCESS;

}				/* ----------  end of function main  ---------- */

template<typename T>
void start_list_with_five_things(T a, T b, T c, T d, T e){

	chainlist::List<T> mylist;
	mylist.insert_front(a);
	mylist.insert_front(b);
	mylist.insert_front(c);
	mylist.insert_front(d);
	mylist.insert_front(e);

std::cout << "The size of List is ==> " << mylist.size() << std::endl;
	mylist.display();
}



template<typename T>
void add_to_list_with_five_things(T a, T b, T c, T d, T e){

	chainlist::List<T> mylist;
	mylist.insert(a);
	chainlist::Node<T> * mynode = mylist.cursor();
	mylist.insert(b, mynode);
	mynode = mylist.cursor();
	mylist.insert(c, mynode);
	mynode = mylist.cursor();
	mylist.insert(d, mynode);
	mynode = mylist.cursor();
	mylist.insert(e, mynode);
	mylist.insert(a);

std::cout << "The size of List is ==> " << mylist.size() << std::endl;
	mylist.display();
}

template<typename T>
void add_to_list_with_five_things_then_find(T a, T b, T c, T d, T e){

	chainlist::List<T> mylist;
	mylist.insert(a);
	chainlist::Node<T> * mynode = mylist.cursor();
	mylist.insert(b, mynode);
	mynode = mylist.cursor();
	mylist.insert(c, mynode);
	mynode = mylist.cursor();
	mylist.insert(d, mynode);
	mynode = mylist.cursor();
	mylist.insert(e, mynode);
	mylist.insert(a);

	mylist.find_value(c);
	mynode = mylist.cursor();
	std::cout << "\n\n**********Searching for Value************" << std::cout;
	std::cout << "Value Found ==> '" << *(mylist.cursor()->value()) << "' at Node ==> " << mylist.cursor() << std::endl;

	std::cout << "The size of List is ==> " << mylist.size() << std::endl;
	mylist.display();
	mylist.cursor(mylist.front());
	chainlist::Node<T> * place = mylist.cursor();
	while(place != mylist.endd()){
		mylist.cursor()=NULL;
		place = place->next();
	}
	mylist.display();
}

chainlist::Node<std::string> * findtest(std::string search_string){
       //open short story

	const char *ifs_file_name = "/home/ruben/bin/tom_walker.txt";		/* input  file name       */
	std::ifstream	ifs;							/* create ifstream object */

	ifs.open (ifs_file_name);		/* open ifstream          */
	if (!ifs) {
		std::cerr << "\nERROR : failed to open input  file " << ifs_file_name << std::endl;
		exit (EXIT_FAILURE);
	}
	chainlist::List<std::string> * tom_walker = new chainlist::List<std::string>;
	chainlist::Node<std::string> * found;
	std::string tmp;
	while (std::getline(ifs,tmp)){
			tom_walker->insert(tmp);
	
	}
	ifs.close ();
	/* close ifstream         */

	tom_walker->find_value(search_string);
	found = tom_walker->cursor();

	

	tom_walker->display();



	return found;
}  // End of findtest

chainlist::List<mess::MESSAGE> get_messages()
{
	chainlist::List<mess::MESSAGE > mylist3;
	mysqlpp:: Connection handle("rubenmail", 0, "ruben", "*****");
	if( handle.connected() ){
		std::cout << "connected\n";
	}else{
		std::cout << "no Connection: " <<   handle.error()  << std::endl;
		exit(1);
	}



	mysqlpp::Query ask(&handle,true, "select id, day, fromit, subject, message  from postings where fromit like \"%francal%\"");
	mysqlpp::Query ask2(&handle,true, "select id, day, fromit, subject, message  from postings where fromit like \"%2013156062%\"");
	mysqlpp::StoreQueryResult::const_iterator place;
	mysqlpp::Row row;
	mysqlpp::StoreQueryResult fran;
	mysqlpp::StoreQueryResult fran_text;
	if((fran = ask.store()) && (fran_text = ask2.store())){

		mess::MESSAGE * onemail = new mess::MESSAGE();
		mess::MESSAGE * twomail = new mess::MESSAGE();
		for(place = fran.begin(); place != fran.end(); ++place){
			row = *place;
			(*onemail)(row[0].c_str(), row[1].c_str(), row[2].c_str(),row[3].c_str(),row[4].c_str());
			mylist3.insert_front(*onemail);
			mylist3.insert(*onemail);
		}
		twomail = onemail;
		std::cout << "Message Copy \n\n" << twomail << *twomail << std::endl;



//		mylist3.display();
		std::cout << "Number of Messages is ==> "<<  mylist3.size() << std::endl;
		mylist3.sort(mylist3);
		int i=0;
		const int fin = mylist3.size(); 
		for( i = 0; i < fin; ++i){
			std::cout << mylist3[i].subject() << std::endl;
		}
	}


	return mylist3 ;
}		/* -----  end of template function get_messages  ----- */


	template <class T>
void find_all_examples ( chainlist::List<T> &glob, const T& search_value )
{
	glob.find_value(search_value);
	chainlist::Node<T> * found = glob.cursor();
	std::cout << "Found first value ==> '" <<*(found->value()) << "' at node =='" << glob.cursor() << std::endl;
	found = glob.find_next_value(search_value, found); 
	while( found ){ 
		std::cout << "Found next value ==> '" << *(found->value()) << "' at node =='" << glob.cursor() << std::endl;
		found = glob.find_next_value(search_value, found);
	}


	return ;
}		/* -----  end of template function find_all_examples  ----- */

chainlist::List<int>& creating_int_list(){
	chainlist::List<int> * set = new chainlist::List<int>;
	srand(12345);
	int ran;
	for(int i = 0; i < 5000; ++i){
		ran=rand();
		set->insert(ran % 101);
	}
	return *set;
}



