/*
 * =====================================================================================
 *
 *       Filename:  message.h
 *
 *    Description:  class that holds MYSQL messages from my mail database
 *
 *        Version:  1.0
 *        Created:  03/30/2011 01:55:54 AM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  YOUR NAME Ruben Safir, 
 *        Company: NYLXS 
 *
 * =====================================================================================
 */

#ifndef MESSAGE_RIS
#define MESSAGE_RIS
#include <iostream>
#include <climits>
#include <cstdlib>
#include <cstdio>
#include<string>
#include <mysql++.h>
#include <iomanip>
#include "stats.h"


namespace mess {
class MESSAGE
{
    friend std::ostream & operator<<(std::ostream &, const MESSAGE&);
    public:
	/* ====================  LIFECYCLE     ======================================= */
	inline MESSAGE():id_("blank"), date_("blank"), from_("blank"), subject_("blank"), message_("blank") {}            /* constructor */
//	inline MESSAGE(int a) {
//	if(a != 0)
//	    std::cerr << "Failed Construction:  Used and interger:  Line==> " << __LINE__ << std::endl;
//
//	}                             /* constructor */
	inline MESSAGE(std::string a,std::string b,std::string c,std::string d,std::string e):id_(a), date_(b), from_(c), subject_(d), message_(e) {}                             /* constructor */

	/* ====================  ACCESSORS     ======================================= */
	inline std::string& id()  { return id_;}
	inline std::string& date()  { return date_;}
	inline std::string& from()  { return from_;}
	inline std::string& subject()  { return subject_;}
	inline std::string& message()  { return message_;}

	inline void id(std::string &par ){id_ = par;}
	inline void date(std::string &par){  date_ = par;}
	inline void from(std::string &par){  from_= par;}
	inline void subject(std::string &par){  subject_ = par;}
	inline void message(std::string &par){  message_ = par;}

	/* ====================  MUTATORS      ======================================= */

	/* ====================  OPERATORS     ======================================= */
	MESSAGE operator()(std::string a, std::string b, std::string c, std::string d, std::string e){ //This is NOT a CONSTRUCTOR
	    id(a);
	    date(b);
	    from(c);
	    subject(d);
	    message(e);
	    return *this;
	}
	bool operator<(MESSAGE val2){
		if(this->subject() < val2.subject()) {
			return true;
		} else{	 
			return false ;
		}
	}

	bool operator>(MESSAGE val2){
		if(this->subject() > val2.subject()) {
			return true;
		} else{	 
			return false ;
		}
	}

	bool operator<=(MESSAGE val2){
		if(this->subject() <= val2.subject()) {
			return true;
		} else{	 
			return false ;
		}
	}

	bool operator>=(MESSAGE val2){
		if(this->subject() >= val2.subject()) {
			return true;
		} else{	 
			return false ;
		}
	}

	bool operator==(MESSAGE val2){
		if(this->subject() == val2.subject()) {
			return true;
		} else{	 
			return false ;
		}
	}

	MESSAGE& operator=( MESSAGE val){
		id(val.id()) ;
		date() = val.date() ;
		from() = val.from() ;
		subject() = val.subject() ;
		message() = val.message() ;
		return *this;
	}

	std::string operator[](int index){

		std::string rval;

		if(index > 4)
			exit(EXIT_FAILURE);		

		switch ( index ) {
			case 0:	rval = id();
				break;

			case 1:	rval = date();
				break;

			case 2:	rval = from();
				break;
			
			case 3:	rval = subject();
				break;

			case 4:	rval = message();
				break;

			default: rval = "ERROR";	
				break;
		}
		return rval;
	}		/* -----  end switch  ----- */





    protected:
	/* ====================  DATA MEMBERS  ======================================= */

    private:
	/* ====================  DATA MEMBERS  ======================================= */
	std::string id_;
	std::string date_;
	std::string from_;
	std::string subject_;
	std::string message_;

}; /* -----  end of class MESSAGE  ----- */

std::ostream & operator<<(std::ostream& outbound, MESSAGE& mes){
    outbound << "ID ==> " << mes.id() << std::endl << "Date==> " << mes.date() << std::endl<< "From==> " << mes.from() << std::endl << "Subject==> " << mes.subject()<< std::endl << mes.message() << std::endl;
    return outbound;
} 

}		/* -----  end of namespace mess  ----- */
#endif
