/*
 * =====================================================================================
 *
 *       Filename:  test_del.cpp
 *
 *    Description:  Testing Double Deletes
 *
 *        Version:  1.0
 *        Created:  04/02/2011 05:12:24 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  YOUR NAME Ruben Safir, 
 *        Company:  NYLXS
 *
 * =====================================================================================
 */



#ifndef  LINKLIST
#define LINKLIST
#include	"linklist.h"
#include       "stats.h"
#endif     /* -----  not LINKLIST  ----- */

#include	<iostream>
#include	<fstream>
#include 	<climits>
#include	<stdlib.h>
#include        <iomanip>

chainlist::List<int>* creating_int_list();
void find_all_examples(chainlist::List<int>*&, int);





chainlist::List<stats::Distribution<int> > * tally;  //a list of distribution talleys in global space
chainlist::List< chainlist::List< stats::Distribution<int> > > * tallies;  //a list of distribution talleys in global space



int main ( int argc, char *argv[] ){

   tally = new chainlist::List<stats::Distribution<int> >;
   tallies = new chainlist::List< chainlist::List< stats::Distribution<int> > >;

   srand(12345);
   unsigned int i;
   chainlist::List<chainlist::List<int> * > a;
   for( i=0; i < 100; ++i){
      std::cout << "CREATING LIST for ARRAY -------------------------------\n";
      a[i] = creating_int_list();
      a[i]->sort(*(a[i]));
      std::cout << "Sorted List" << std::endl;
//      a[i]->display();
      std::cout << std::endl; 
   }
   a.sort(a);


   for( i=0; i < 100; ++i){
      std::cout << "NEW SEARCH in index " << i << "-------------------------------\n";
      stats::take_tally<int>(a[i], tally);
   }
   std::cout << "The standard mean is ==> " << stats::mean_list(tally) << std::endl;
   std::cout << "The standard deviation is ==> " << stats::stddev(tally) << std::endl;
//   tally->display();
   delete tally;

   std::cout << "tally deleted - next loop " << std::endl;



//test of new stddev overload that takes a list of lists of distributions

   for( i=0; i < 100; ++i){
      std::cout << "index " << i << "-------------------------------\n";
      tally = new chainlist::List<stats::Distribution<int> >;
      stats::take_tally<int>(a[i], tally );
      std::cout << "Creating Tally " << std::endl;
      tallies->insert(*tally);
      std::cout << "inserted population figures for index " << i << "-------------------------------\n";
      delete tally;

//visual inspection of population data to make sure the resiults work
//      std::cout << "visual inspection of population data to make sure the results work" << std::endl;
//      for(j=0;j < 100; j++){
//	 std::cout << "NEW SEARCH in value " << j << "-------------------------------\n";
//	 find_all_examples(a[i], j);
//      }
   }
   std::cout << "The standard mean for picking 7 is ==> " << stats::mean_list(tallies, 7 );
   std::cout << "The standard deviation for 7 in our test is ==> " << stats::stddev(tallies, 7);
   

   return EXIT_SUCCESS;
}				/* ----------  end of function main  ---------- */


chainlist::List<int> * creating_int_list(){
   // chainlist::List<int>  set = new chainlist::List<int>;
   chainlist::List<int> * set = new chainlist::List<int>;
   int ran;
   for(int i = 0; i < 100; ++i){
      ran=rand();
      set->insert(ran % 100);
   }
   set->display();
   return set;
}

void find_all_examples ( chainlist::List<int>* & glob, int search_value )
{
   std::cout << "Searching for " <<  search_value << " in list \n" ;
   glob->display();
   glob->find_value(search_value);
   chainlist::Node<int> * found = glob->cursor();
   if(found){
      std::cout << "Found first value ==> '" << *found->value() << "' at node =='" << glob->cursor() << std::endl;
      found = glob->find_next_value(search_value, found); 
      while( found ){ 
	 std::cout << "Found next value ==> '" << *(found->value()) << "' at node =='" << glob->cursor() << std::endl;
	 found = glob->find_next_value(search_value, found);
      }
   }


   return ;
}		

